#include "arrayf.h"

CArrayfApp ArrayfApp;

BOOL CArrayfApp::InitInstance()
{
   char *tok;
   char cmd[256];
   CLSID clsid;
   COleException e;
   HRESULT hr;
   LPDISPATCH lpDispatch;
   LPUNKNOWN lpUnk;
   UINT size, arraynum, recnum, value;

   if (strlen(m_lpCmdLine) == 0)
   {
      PostMsg("USAGE: ARRAYF [U/D/N/A/R/S/G/F/W/C] {options}");
      return TRUE;
   }
   if (!AfxOleInit())
   {
      PostMsg("ERROR: OLE Initialization failed");
      return FALSE;
   }
   if (CLSIDFromProgID(OLESTR("ah.Server"), &clsid) != S_OK)
   {
      PostMsg("ERROR: Could not find CLSID for AH");
      return FALSE;
   }
   // We don't want to create a dispatch in this app
   if (GetActiveObject(clsid, NULL, &lpUnk) != S_OK)
   {
      PostMsg("ERROR: Could not find active AH");
      return FALSE;
   }
   hr = lpUnk->QueryInterface(IID_IDispatch,
      (LPVOID*)&lpDispatch);
   lpUnk->Release();
   if (hr == NOERROR)
      ah.AttachDispatch(lpDispatch, TRUE);
   if (ah.m_lpDispatch == NULL)
   {
      PostMsg("ERROR: Could not attach to AH");
      return FALSE;
   }
   strcpy(cmd,m_lpCmdLine);
   tok = strtok(cmd," ");
   switch(tolower(tok[0]))
   {
      case 'u':
         ah.UserAdd();
         break;
      case 'd':
         ah.DropUser();
         break;
      case 'n':
         PostResult(ah.NumUsers());
         break;
      case 'a':
         tok = strtok(NULL," ");
         size = atoi(tok);
         PostResult(ah.AddArray(size));
         break;
      case 'r':
         tok = strtok(NULL," ");
         arraynum = atoi(tok);
         PostBResult(ah.RemoveArray(arraynum));
         break;
      case 's':
         tok = strtok(NULL," ");
         arraynum = atoi(tok);
         tok = strtok(NULL," ");
         recnum = atoi(tok);
         tok = strtok(NULL," ");
         value = atoi(tok);
         PostBResult(ah.SetRecord(arraynum,recnum,value));
         break;
      case 'g':
         tok = strtok(NULL," ");
         arraynum = atoi(tok);
         tok = strtok(NULL," ");
         recnum = atoi(tok);
         PostResult(ah.GetRecord(arraynum,recnum));
         break;
      case 'f':
         tok = strtok(NULL," ");
         arraynum = atoi(tok);
         tok = strtok(NULL,"\"");
         SetFromFile(arraynum,tok);
         break;
      case 'w':
         tok = strtok(NULL," ");
         arraynum = atoi(tok);
         tok = strtok(NULL,"\"");
         SetFromWinSel(arraynum,tok);
         break;
      case 'c':
         ah.Close();
         break;
      default:
         PostMsg("ERROR: Invalid Option");
         return FALSE;
   }
   return TRUE;
}

void CArrayfApp::SetFromFile(UINT arraynum, LPCTSTR fName)
{
   FILE *infile;
   char input[81];
   UINT recnum = 0;
   UINT value;
   BOOL result;

   if ((infile = fopen(fName,"r")) == NULL)
   {
      PostMsg("ERROR: Could not open file");
      return;
   }
   while (fgets(input, 80, infile) != NULL)
   {
      value = atoi(input);
      result = ah.SetRecord(arraynum,recnum,value);
      recnum++;
   }
   fclose(infile);
   PostBResult(TRUE);
   return;
}

void CArrayfApp::SetFromWinSel(UINT arraynum, LPCTSTR fName)
{
   FILE *infile;
   BYTE input;
   UINT recnum = 0;
   UINT value = 1;
   BOOL result;

   if ((infile = fopen(fName,"rb")) == NULL)
   {
      PostMsg("ERROR: Could not open file");
      return;
   }
   while (fread(&input, sizeof(input), 1, infile) != 0)
   {
      for(int i = 0;i < 8;i++)
      {
         if (input & 1)
         {
            result = ah.SetRecord(arraynum,recnum,value);
            recnum++;
         }
         input = input >> 1;
         value++;
      }
   }
   fclose(infile);
   PostBResult(TRUE);
   return;
}

void CArrayfApp::PostMsg(LPCTSTR Msg)
{
   HGLOBAL hg;
   int i;
   LPTSTR lp;

   if (!OpenClipboard(NULL))
   {
      THROW("Cannot open the Clipboard");
      return;
   }
   EmptyClipboard();
   i = strlen(Msg);
   hg = GlobalAlloc(GMEM_DDESHARE,
       (i + 1) * sizeof(TCHAR));
   if (hg == NULL)
   {
      THROW("Unable to allocate handle");
      CloseClipboard();
      return;
   }
   lp = (LPTSTR) GlobalLock(hg);
   memcpy(lp, Msg, i * sizeof(TCHAR));
   lp[i] = (TCHAR) 0;
   GlobalUnlock(hg);
   SetClipboardData(CF_TEXT,hg);
   CloseClipboard();
   return;
}

void CArrayfApp::PostResult(UINT Result)
{
   char r[20];

   _itoa(Result,r,10);
   PostMsg(r);
   return;
}

void CArrayfApp::PostBResult(BOOL BResult)
{
   if (BResult)
      PostMsg(".TRUE.");
   else
      PostMsg(".FALSE.");
   return;
}


